//   :
//   -     O(n^2)
//   -     O(n^3)
//     .
//           2004 
//         .

#include<stdio.h>
#include<string.h>
#include<stdlib.h>

char *lines[3];	// 

inline int GetMin(int a,int b) {return a>b?b:a;}
inline int GetMax(int a,int b) {return a>b?a:b;}
inline int GetMin(int a,int b,int c) {return GetMin(a,GetMin(b,c));}
inline int GetMax(int a,int b,int c) {return GetMax(a,GetMax(b,c));}

//       (   )
void Check(int index,int min,int max)
{
	if(index>=min && index<max) return;
	printf("out of index\n\a"); exit(-2);
}




//       .  O(n^2)
int FindMax2()
{
	int offset1,offset2;
	int len1,len2,m0,m1,n,m,max,count;
	max=0;
	len1=strlen(lines[0]);
	len2=strlen(lines[1]);
	for(n=-len2+1; n<len1; n++) {
		count=0;
		m0=GetMax(0,-n);
		m1=GetMin(len1-n,len2);
		for(m=m0; m<m1; m++) {
			Check(n+m,0,len1);
			Check(m  ,0,len2);
			//  
			// if(n+m<0 || n+m>=len1) _asm { int 3 }
			// if(m<0 || m>=len2) _asm { int 3 }
			if(lines[0][n+m]==lines[1][m]) 
				count++; 
			else count=0;
			if(count>max)
				max=count,offset1=n+m-max+1,offset2=m-max+1;
		}
	}
	if(max) {
		printf("test(%d,%d)=",offset1,offset2);
		for(n=0; n<max; n++) putchar(lines[0][offset1+n]); putchar('\n');
	}
	return max;
}


//       .  O(n^3)
int FindMax3()
{
	int offset1,offset2,offset3;
	int len1,len2,len3;
	int max,count,x,y,z,z0,z1;
	max=0;
	len1=strlen(lines[0]);
	len2=strlen(lines[1]);
	len3=strlen(lines[2]);
	for(x=1-len3; x<len1; x++) {
		for(y=1-len3; y<len2; y++) {
			count=0;
			z0=GetMax(0,-x,-y);
			z1=GetMin(len1-x,len2-y,len3);
			for(z=z0; z<z1; z++) {
				Check(x+z,0,len1);
				Check(y+z,0,len2);
				Check(z  ,0,len3);
				//  
				// if(x+z<0 || x+z>=len1) _asm { int 3 }
				// if(y+z<0 || y+z>=len2) _asm { int 3 }
				// if(z  <0 ||   z>=len3) _asm { int 3 }
				if(lines[0][x+z]==lines[2][z] && lines[1][y+z]==lines[2][z]) count++; 
				else count=0;
				if(count>max) max=count,offset1=x+z-max+1,offset2=y+z-max+1,offset3=z-max+1;
			}
		}
	}
	if(max) {
		printf("test(%d,%d,%d)=",offset1,offset2,offset3);
		for(x=0; x<max; x++) putchar(lines[0][offset1+x]); putchar('\n');
	}
	return max;
}




void main()
{
	int n;
	char buffer1[100],buffer2[100],buffer3[100]; //   
	lines[0]=buffer1;
	lines[1]=buffer2;
	lines[2]=buffer3;
	for(n=0; n<60+rand()%15; n++) buffer1[n]='0'+rand()%10; buffer1[n]=0;
	for(n=0; n<60+rand()%15; n++) buffer2[n]='0'+rand()%10; buffer2[n]=0;
	for(n=0; n<60+rand()%15; n++) buffer3[n]='0'+rand()%10; buffer3[n]=0;
	for(n=0; n<3; n++) printf("l%d=%s\n",n+1,lines[n]);
	FindMax2();
	FindMax3();
	printf("[press enter]\n"); getchar();
}


